Index: palm/trunk/SOURCE/radiation_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/radiation_model_mod.f90	(revision 3322)
+++ palm/trunk/SOURCE/radiation_model_mod.f90	(revision 3337)
@@ -4722,6 +4880,18 @@
          CALL MPI_AllGatherv(surfoutsl, nsurfl, MPI_REAL, &
              surfouts, nsurfs, surfstart, MPI_REAL, comm2d, ierr)
+         IF ( ierr /= 0 ) THEN
+             WRITE(9,*) 'Error MPI_AllGatherv2:', ierr, SIZE(surfoutsl), nsurfl, &
+                        SIZE(surfouts), nsurfs, surfstart
+             FLUSH(9)
+         ENDIF
+
          CALL MPI_AllGatherv(surfoutll, nsurfl, MPI_REAL, &
              surfoutl, nsurfs, surfstart, MPI_REAL, comm2d, ierr)
+         IF ( ierr /= 0 ) THEN
+             WRITE(9,*) 'Error MPI_AllGatherv3:', ierr, SIZE(surfoutll), nsurfl, &
+                        SIZE(surfoutl), nsurfs, surfstart
+             FLUSH(9)
+         ENDIF
+
 #else
          surfouts = surfoutsl
@@ -4747,5 +4917,13 @@
              IF ( isurfsrc == -1 )  CYCLE ! sky->face only in 1st pass, not here
 
-             pcbinsw(ipcgb) = pcbinsw(ipcgb) + csf(1,icsf) * csf(2,icsf) * surfouts(isurfsrc)
+             pcbinsw(ipcgb) = pcbinsw(ipcgb) + csf(1,icsf) * surfouts(isurfsrc)
+         ENDDO
+!
+!--      MRT reflected
+         DO  imrtf = 1, nmrtf
+            imrt = mrtfsurf(1, imrtf)
+            isurfsrc = mrtfsurf(2, imrtf)
+            mrtinsw(imrt) = mrtinsw(imrt) + mrtft(imrtf) * surfouts(isurfsrc)
+            mrtinlw(imrt) = mrtinlw(imrt) + mrtf(imrtf) * surfoutl(isurfsrc)
          ENDDO
 
@@ -4755,5 +4933,5 @@
          surfoutlw = surfoutlw + surfoutll
 
-     ENDDO
+     ENDDO ! refstep
 
 !--  push heat flux absorbed by plant canopy to respective 3D arrays
@@ -4778,4 +4956,13 @@
      ENDIF
 !
+!--  Calculate black body MRT (after all reflections)
+     IF ( nmrtbl > 0 )  THEN
+        IF ( mrt_include_sw )  THEN
+           mrt(:) = ((mrtinsw(:) + mrtinlw(:)) / sigma_sb) ** .25_wp
+        ELSE
+           mrt(:) = (mrtinlw(:) / sigma_sb) ** .25_wp
+        ENDIF
+     ENDIF
+!
 !--     Transfer radiation arrays required for energy balance to the respective data types
      DO  i = 1, nsurfl
@@ -4791,4 +4978,5 @@
            surf_usm_h%rad_net(m)    = surfinsw(i) - surfoutsw(i) +          &
                                       surfinlw(i) - surfoutlw(i)
+           surf_usm_h%rad_net_l(m)  = surf_usm_h%rad_net(m)
 !
 !--     northward-facding
@@ -4800,4 +4988,5 @@
            surf_usm_v(0)%rad_net(m)    = surfinsw(i) - surfoutsw(i) +       &
                                          surfinlw(i) - surfoutlw(i)
+           surf_usm_v(0)%rad_net_l(m)  = surf_usm_v(0)%rad_net(m)
 !
 !--     southward-facding
@@ -4809,4 +4998,5 @@
            surf_usm_v(1)%rad_net(m)    = surfinsw(i) - surfoutsw(i) +       &
                                          surfinlw(i) - surfoutlw(i)
+           surf_usm_v(1)%rad_net_l(m)  = surf_usm_v(1)%rad_net(m)
 !
 !--     eastward-facing
@@ -4818,4 +5008,5 @@
            surf_usm_v(2)%rad_net(m)    = surfinsw(i) - surfoutsw(i) +       &
                                          surfinlw(i) - surfoutlw(i)
+           surf_usm_v(2)%rad_net_l(m)  = surf_usm_v(2)%rad_net(m)
 !
 !--     westward-facding
@@ -4827,4 +5018,5 @@
            surf_usm_v(3)%rad_net(m)    = surfinsw(i) - surfoutsw(i) +       &
                                          surfinlw(i) - surfoutlw(i)
+           surf_usm_v(3)%rad_net_l(m)  = surf_usm_v(3)%rad_net(m)
 !
 !--     (2) land surfaces
@@ -4957,10 +5149,38 @@
 #if defined( __parallel )
      CALL MPI_ALLREDUCE( pinswl, pinsw, 1, MPI_REAL, MPI_SUM, comm2d, ierr)
+     IF ( ierr /= 0 ) THEN
+         WRITE(9,*) 'Error MPI_AllReduce5:', ierr, pinswl, pinsw
+         FLUSH(9)
+     ENDIF
      CALL MPI_ALLREDUCE( pinlwl, pinlw, 1, MPI_REAL, MPI_SUM, comm2d, ierr)
+     IF ( ierr /= 0 ) THEN
+         WRITE(9,*) 'Error MPI_AllReduce6:', ierr, pinlwl, pinlw
+         FLUSH(9)
+     ENDIF
      CALL MPI_ALLREDUCE( pabsswl, pabssw, 1, MPI_REAL, MPI_SUM, comm2d, ierr )
+     IF ( ierr /= 0 ) THEN
+         WRITE(9,*) 'Error MPI_AllReduce7:', ierr, pabsswl, pabssw
+         FLUSH(9)
+     ENDIF
      CALL MPI_ALLREDUCE( pabslwl, pabslw, 1, MPI_REAL, MPI_SUM, comm2d, ierr )
+     IF ( ierr /= 0 ) THEN
+         WRITE(9,*) 'Error MPI_AllReduce8:', ierr, pabslwl, pabslw
+         FLUSH(9)
+     ENDIF
      CALL MPI_ALLREDUCE( pemitlwl, pemitlw, 1, MPI_REAL, MPI_SUM, comm2d, ierr )
+     IF ( ierr /= 0 ) THEN
+         WRITE(9,*) 'Error MPI_AllReduce8:', ierr, pemitlwl, pemitlw
+         FLUSH(9)
+     ENDIF
      CALL MPI_ALLREDUCE( emiss_sum_surfl, emiss_sum_surf, 1, MPI_REAL, MPI_SUM, comm2d, ierr )
+     IF ( ierr /= 0 ) THEN
+         WRITE(9,*) 'Error MPI_AllReduce9:', ierr, emiss_sum_surfl, emiss_sum_surf
+         FLUSH(9)
+     ENDIF
      CALL MPI_ALLREDUCE( area_surfl, area_surf, 1, MPI_REAL, MPI_SUM, comm2d, ierr )
+     IF ( ierr /= 0 ) THEN
+         WRITE(9,*) 'Error MPI_AllReduce10:', ierr, area_surfl, area_surf
+         FLUSH(9)
+     ENDIF
 #else
      pinsw = pinswl
@@ -5038,4 +5258,5 @@
 !      t_rad_urb = pt_surf_urb / count_surfaces
      
+
     CONTAINS
 
@@ -5201,6 +5422,11 @@
        INTEGER(iwp) :: i, j, k, l, m
        INTEGER(iwp) :: k_topo     !< vertical index indicating topography top for given (j,i)
-       INTEGER(iwp) :: nzptl, nzubl, nzutl, isurf, ipcgb
+       INTEGER(iwp) :: nzptl, nzubl, nzutl, isurf, ipcgb, imrt
        REAL(wp)     :: mrl
+#if defined( __parallel )
+       INTEGER(iwp), DIMENSION(:), POINTER       ::  gridsurf_rma   !< fortran pointer, but lower bounds are 1
+       TYPE(c_ptr)                               ::  gridsurf_rma_p !< allocated c pointer
+       INTEGER(iwp)                              ::  minfo          !< MPI RMA window info handle
+#endif
 
 
@@ -5263,6 +5489,18 @@
 #if defined( __parallel )
        CALL MPI_AllReduce(nzubl, nzub, 1, MPI_INTEGER, MPI_MIN, comm2d, ierr )
+       IF ( ierr /= 0 ) THEN
+           WRITE(9,*) 'Error MPI_AllReduce11:', ierr, nzubl, nzub
+           FLUSH(9)
+       ENDIF
        CALL MPI_AllReduce(nzutl, nzut, 1, MPI_INTEGER, MPI_MAX, comm2d, ierr )
+       IF ( ierr /= 0 ) THEN
+           WRITE(9,*) 'Error MPI_AllReduce12:', ierr, nzutl, nzut
+           FLUSH(9)
+       ENDIF
        CALL MPI_AllReduce(nzptl, nzpt, 1, MPI_INTEGER, MPI_MAX, comm2d, ierr )
+       IF ( ierr /= 0 ) THEN
+           WRITE(9,*) 'Error MPI_AllReduce13:', ierr, nzptl, nzpt
+           FLUSH(9)
+       ENDIF
 #else
        nzub = nzubl
@@ -5353,6 +5591,71 @@
 !--    cycles must not be altered, certain file input routines may depend
 !--    on it)
-       ALLOCATE(surfl(5,nsurfl))  ! is it mecessary to allocate it with (5,nsurfl)?
+       ALLOCATE(surfl_l(5*nsurfl))  ! is it necessary to allocate it with (5,nsurfl)?
+       surfl(1:5,1:nsurfl) => surfl_l(1:5*nsurfl)
        isurf = 0
+       IF ( rad_angular_discretization )  THEN
+!
+!--       Allocate and fill the reverse indexing array gridsurf
+#if defined( __parallel )
+!
+!--       raytrace_mpi_rma is asserted
+
+          CALL MPI_Info_create(minfo, ierr)
+          IF ( ierr /= 0 ) THEN
+              WRITE(9,*) 'Error MPI_Info_create1:', ierr
+              FLUSH(9)
+          ENDIF
+          CALL MPI_Info_set(minfo, 'accumulate_ordering', '', ierr)
+          IF ( ierr /= 0 ) THEN
+              WRITE(9,*) 'Error MPI_Info_set1:', ierr
+              FLUSH(9)
+          ENDIF
+          CALL MPI_Info_set(minfo, 'accumulate_ops', 'same_op', ierr)
+          IF ( ierr /= 0 ) THEN
+              WRITE(9,*) 'Error MPI_Info_set2:', ierr
+              FLUSH(9)
+          ENDIF
+          CALL MPI_Info_set(minfo, 'same_size', 'true', ierr)
+          IF ( ierr /= 0 ) THEN
+              WRITE(9,*) 'Error MPI_Info_set3:', ierr
+              FLUSH(9)
+          ENDIF
+          CALL MPI_Info_set(minfo, 'same_disp_unit', 'true', ierr)
+          IF ( ierr /= 0 ) THEN
+              WRITE(9,*) 'Error MPI_Info_set4:', ierr
+              FLUSH(9)
+          ENDIF
+
+          CALL MPI_Win_allocate(INT(STORAGE_SIZE(1_iwp)/8*nsurf_type_u*nzu*nny*nnx, &
+                                    kind=MPI_ADDRESS_KIND),                         &
+                                INT(STORAGE_SIZE(1_iwp)/8, kind=MPI_ADDRESS_KIND),  &
+                                minfo, comm2d, gridsurf_rma_p, win_gridsurf, ierr)
+          IF ( ierr /= 0 ) THEN
+              WRITE(9,*) 'Error MPI_Win_allocate1:', ierr, &
+                 INT(STORAGE_SIZE(1_iwp)/8*nsurf_type_u*nzu*nny*nnx,kind=MPI_ADDRESS_KIND), &
+                 INT(STORAGE_SIZE(1_iwp)/8, kind=MPI_ADDRESS_KIND), win_gridsurf
+              FLUSH(9)
+          ENDIF
+
+          CALL MPI_Info_free(minfo, ierr)
+          IF ( ierr /= 0 ) THEN
+              WRITE(9,*) 'Error MPI_Info_free1:', ierr
+              FLUSH(9)
+          ENDIF
+
+!
+!--       On Intel compilers, calling c_f_pointer to transform a C pointer
+!--       directly to a multi-dimensional Fotran pointer leads to strange
+!--       errors on dimension boundaries. However, transforming to a 1D
+!--       pointer and then redirecting a multidimensional pointer to it works
+!--       fine.
+          CALL c_f_pointer(gridsurf_rma_p, gridsurf_rma, (/ nsurf_type_u*nzu*nny*nnx /))
+          gridsurf(0:nsurf_type_u-1, nzub:nzut, nys:nyn, nxl:nxr) =>                &
+                     gridsurf_rma(1:nsurf_type_u*nzu*nny*nnx)
+#else
+          ALLOCATE(gridsurf(0:nsurf_type_u-1,nzub:nzut,nys:nyn,nxl:nxr) )
+#endif
+          gridsurf(:,:,:,:) = -999
+       ENDIF
 
 !--    add horizontal surface elements (land and urban surfaces)
@@ -5362,14 +5665,18 @@
               DO  m = surf_usm_h%start_index(j,i), surf_usm_h%end_index(j,i)
                  k = surf_usm_h%k(m)
-
                  isurf = isurf + 1
                  surfl(:,isurf) = (/iup_u,k,j,i,m/)
+                 IF ( rad_angular_discretization ) THEN
+                    gridsurf(iup_u,k,j,i) = isurf
+                 ENDIF
               ENDDO
 
               DO  m = surf_lsm_h%start_index(j,i), surf_lsm_h%end_index(j,i)
                  k = surf_lsm_h%k(m)
-
                  isurf = isurf + 1
                  surfl(:,isurf) = (/iup_l,k,j,i,m/)
+                 IF ( rad_angular_discretization ) THEN
+                    gridsurf(iup_u,k,j,i) = isurf
+                 ENDIF
               ENDDO
 
@@ -5384,13 +5691,17 @@
               DO  m = surf_usm_v(l)%start_index(j,i), surf_usm_v(l)%end_index(j,i)
                  k = surf_usm_v(l)%k(m)
-
-                 isurf          = isurf + 1
+                 isurf = isurf + 1
                  surfl(:,isurf) = (/inorth_u,k,j,i,m/)
+                 IF ( rad_angular_discretization ) THEN
+                    gridsurf(inorth_u,k,j,i) = isurf
+                 ENDIF
               ENDDO
               DO  m = surf_lsm_v(l)%start_index(j,i), surf_lsm_v(l)%end_index(j,i)
                  k = surf_lsm_v(l)%k(m)
-
-                 isurf          = isurf + 1
+                 isurf = isurf + 1
                  surfl(:,isurf) = (/inorth_l,k,j,i,m/)
+                 IF ( rad_angular_discretization ) THEN
+                    gridsurf(inorth_u,k,j,i) = isurf
+                 ENDIF
               ENDDO
 
@@ -5398,13 +5709,17 @@
               DO  m = surf_usm_v(l)%start_index(j,i), surf_usm_v(l)%end_index(j,i)
                  k = surf_usm_v(l)%k(m)
-
-                 isurf          = isurf + 1
+                 isurf = isurf + 1
                  surfl(:,isurf) = (/isouth_u,k,j,i,m/)
+                 IF ( rad_angular_discretization ) THEN
+                    gridsurf(isouth_u,k,j,i) = isurf
+                 ENDIF
               ENDDO
               DO  m = surf_lsm_v(l)%start_index(j,i), surf_lsm_v(l)%end_index(j,i)
                  k = surf_lsm_v(l)%k(m)
-
-                 isurf          = isurf + 1
+                 isurf = isurf + 1
                  surfl(:,isurf) = (/isouth_l,k,j,i,m/)
+                 IF ( rad_angular_discretization ) THEN
+                    gridsurf(isouth_u,k,j,i) = isurf
+                 ENDIF
               ENDDO
 
@@ -5412,13 +5727,17 @@
               DO  m = surf_usm_v(l)%start_index(j,i), surf_usm_v(l)%end_index(j,i)
                  k = surf_usm_v(l)%k(m)
-
-                 isurf          = isurf + 1
+                 isurf = isurf + 1
                  surfl(:,isurf) = (/ieast_u,k,j,i,m/)
+                 IF ( rad_angular_discretization ) THEN
+                    gridsurf(ieast_u,k,j,i) = isurf
+                 ENDIF
               ENDDO
               DO  m = surf_lsm_v(l)%start_index(j,i), surf_lsm_v(l)%end_index(j,i)
                  k = surf_lsm_v(l)%k(m)
-
-                 isurf          = isurf + 1
+                 isurf = isurf + 1
                  surfl(:,isurf) = (/ieast_l,k,j,i,m/)
+                 IF ( rad_angular_discretization ) THEN
+                    gridsurf(ieast_u,k,j,i) = isurf
+                 ENDIF
               ENDDO
 
@@ -5426,16 +5745,72 @@
               DO  m = surf_usm_v(l)%start_index(j,i), surf_usm_v(l)%end_index(j,i)
                  k = surf_usm_v(l)%k(m)
-
-                 isurf          = isurf + 1
+                 isurf = isurf + 1
                  surfl(:,isurf) = (/iwest_u,k,j,i,m/)
+                 IF ( rad_angular_discretization ) THEN
+                    gridsurf(iwest_u,k,j,i) = isurf
+                 ENDIF
               ENDDO
               DO  m = surf_lsm_v(l)%start_index(j,i), surf_lsm_v(l)%end_index(j,i)
                  k = surf_lsm_v(l)%k(m)
-
-                 isurf          = isurf + 1
+                 isurf = isurf + 1
                  surfl(:,isurf) = (/iwest_l,k,j,i,m/)
+                 IF ( rad_angular_discretization ) THEN
+                    gridsurf(iwest_u,k,j,i) = isurf
+                 ENDIF
               ENDDO
            ENDDO
        ENDDO
+!
+!--    Add local MRT boxes for specified number of levels
+       nmrtbl = 0
+       IF ( mrt_nlevels > 0 )  THEN
+          DO  i = nxl, nxr
+             DO  j = nys, nyn
+                DO  m = surf_usm_h%start_index(j,i), surf_usm_h%end_index(j,i)
+!
+!--                Skip roof if requested
+                   IF ( mrt_skip_roof  .AND.  surf_usm_h%isroof_surf(m) )  CYCLE
+!
+!--                Cycle over specified no of levels
+                   nmrtbl = nmrtbl + mrt_nlevels
+                ENDDO
+!
+!--             Dtto for LSM
+                DO  m = surf_lsm_h%start_index(j,i), surf_lsm_h%end_index(j,i)
+                   nmrtbl = nmrtbl + mrt_nlevels
+                ENDDO
+             ENDDO
+          ENDDO
+
+          ALLOCATE( mrtbl(iz:ix,nmrtbl), mrtsky(nmrtbl), mrtskyt(nmrtbl), &
+                    mrtinsw(nmrtbl), mrtinlw(nmrtbl), mrt(nmrtbl) )
+
+          imrt = 0
+          DO  i = nxl, nxr
+             DO  j = nys, nyn
+                DO  m = surf_usm_h%start_index(j,i), surf_usm_h%end_index(j,i)
+!
+!--                Skip roof if requested
+                   IF ( mrt_skip_roof  .AND.  surf_usm_h%isroof_surf(m) )  CYCLE
+!
+!--                Cycle over specified no of levels
+                   l = surf_usm_h%k(m)
+                   DO  k = l, l + mrt_nlevels - 1
+                      imrt = imrt + 1
+                      mrtbl(:,imrt) = (/k,j,i/)
+                   ENDDO
+                ENDDO
+!
+!--             Dtto for LSM
+                DO  m = surf_lsm_h%start_index(j,i), surf_lsm_h%end_index(j,i)
+                   l = surf_lsm_h%k(m)
+                   DO  k = l, l + mrt_nlevels - 1
+                      imrt = imrt + 1
+                      mrtbl(:,imrt) = (/k,j,i/)
+                   ENDDO
+                ENDDO
+             ENDDO
+          ENDDO
+       ENDIF
 
 !
@@ -5458,4 +5833,9 @@
 #if defined( __parallel )
        CALL MPI_Allgather(nsurfl,1,MPI_INTEGER,nsurfs,1,MPI_INTEGER,comm2d,ierr)
+       IF ( ierr /= 0 ) THEN
+         WRITE(9,*) 'Error MPI_AllGather1:', ierr, nsurfl, nsurfs
+         FLUSH(9)
+     ENDIF
+
 #else
        nsurfs(0) = nsurfl
@@ -5469,9 +5849,15 @@
        surfstart(numprocs) = k
        nsurf = k
-       ALLOCATE(surf(5,nsurf))
+       ALLOCATE(surf_l(5*nsurf))
+       surf(1:5,1:nsurf) => surf_l(1:5*nsurf)
 
 #if defined( __parallel )
-       CALL MPI_AllGatherv(surfl, nsurfl*5, MPI_INTEGER, surf, nsurfs*5, &
+       CALL MPI_AllGatherv(surfl_l, nsurfl*5, MPI_INTEGER, surf_l, nsurfs*5, &
            surfstart(0:numprocs-1)*5, MPI_INTEGER, comm2d, ierr)
+       IF ( ierr /= 0 ) THEN
+           WRITE(9,*) 'Error MPI_AllGatherv4:', ierr, SIZE(surfl_l), nsurfl*5, &
+                      SIZE(surf_l), nsurfs*5, surfstart(0:numprocs-1)*5
+           FLUSH(9)
+       ENDIF
 #else
        surf = surfl
@@ -5534,5 +5920,5 @@
         
         INTEGER(iwp)                                  :: i, j, k, d, ip, jp
-        INTEGER(iwp)                                  :: isvf, ksvf, icsf, kcsf, npcsfl, isvf_surflt, imrtt, imrtf, ipcgb
+        INTEGER(iwp)                                  :: isvf, ksvf, icsf, kcsf, npcsfl, isvf_surflt, imrt, imrtf, ipcgb
         INTEGER(iwp)                                  :: sd, td
         INTEGER(iwp)                                  :: iaz, izn      !< azimuth, zenith counters
@@ -5542,15 +5928,26 @@
         REAL(wp)                                      :: az1, az2      !< relative azimuth of section borders
         REAL(wp)                                      :: azmid         !< ray (center) azimuth
-        REAL(wp)                                      :: horizon       !< computed horizon height (tangent of elevation)
-        REAL(wp)                                      :: azen          !< zenith angle
         REAL(wp), DIMENSION(2)                        :: yxdir         !< y,x *unit* vector of ray direction (in grid units)
         REAL(wp), DIMENSION(:), ALLOCATABLE           :: zdirs         !< directions in z (tangent of elevation)
         REAL(wp), DIMENSION(:), ALLOCATABLE           :: zbdry         !< zenith angle boundaries
         REAL(wp), DIMENSION(:), ALLOCATABLE           :: vffrac        !< view factor fractions for individual rays
+        REAL(wp), DIMENSION(:), ALLOCATABLE           :: vffrac0       !< dtto (original values)
         REAL(wp), DIMENSION(:), ALLOCATABLE           :: ztransp       !< array of transparency in z steps
+        INTEGER(iwp)                                  :: lowest_free_ray !< index into zdirs
+        INTEGER(iwp), DIMENSION(:), ALLOCATABLE       :: itarget       !< face indices of detected obstacles
+        INTEGER(iwp)                                  :: itarg0, itarg1
+#if defined( __parallel )
+#endif
+
+
+
         REAL(wp),     DIMENSION(0:nsurf_type)         :: facearea
-        INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE     :: nzterrl
-        REAL(wp),     DIMENSION(:,:), ALLOCATABLE     :: csflt, pcsflt
-        INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE     :: kcsflt,kpcsflt
+        INTEGER(iwp)                                  :: udim
+        INTEGER(iwp), DIMENSION(:), ALLOCATABLE,TARGET:: nzterrl_l
+        INTEGER(iwp), DIMENSION(:,:), POINTER         :: nzterrl
+        REAL(wp),     DIMENSION(:), ALLOCATABLE,TARGET:: csflt_l, pcsflt_l
+        REAL(wp),     DIMENSION(:,:), POINTER         :: csflt, pcsflt
+        INTEGER(iwp), DIMENSION(:), ALLOCATABLE,TARGET:: kcsflt_l,kpcsflt_l
+        INTEGER(iwp), DIMENSION(:,:), POINTER         :: kcsflt,kpcsflt
         INTEGER(iwp), DIMENSION(:), ALLOCATABLE       :: icsflt,dcsflt,ipcsflt,dpcsflt
         REAL(wp), DIMENSION(3)                        :: uv
@@ -5561,6 +5958,6 @@
         INTEGER(idp)                                  :: ray_skip_maxdist, ray_skip_minval !< skipped raytracing counts
         INTEGER(iwp)                                  :: max_track_len !< maximum 2d track length
-        INTEGER(iwp)                                  :: win_lad, minfo
-        REAL(wp), DIMENSION(:,:,:), POINTER           :: lad_s_rma       !< fortran pointer, but lower bounds are 1
+        INTEGER(iwp)                                  :: minfo
+        REAL(wp), DIMENSION(:), POINTER               :: lad_s_rma       !< fortran 1D pointer
         TYPE(c_ptr)                                   :: lad_s_rma_p     !< allocated c pointer
 #if defined( __parallel )
@@ -5569,9 +5966,9 @@
 !    
         INTEGER(iwp), DIMENSION(0:svfnorm_report_num) :: svfnorm_counts
-!        CHARACTER(200)                                :: msg
+        CHARACTER(200)                                :: msg
 
 !--     calculation of the SVF
         CALL location_message( '    calculation of SVF and CSF', .TRUE. )
-!         CALL radiation_write_debug_log('Start calculation of SVF and CSF')
+        CALL radiation_write_debug_log('Start calculation of SVF and CSF')
 
 !--     precalculate face areas for different face directions using normal vector
@@ -5596,4 +5993,11 @@
             acsf => acsf1
         ENDIF
+        nmrtf = 0
+        IF ( mrt_nlevels > 0 )  THEN
+           nmrtfa = gasize
+           mmrtf = 1
+           ALLOCATE ( amrtf1(nmrtfa) )
+           amrtf => amrtf1
+        ENDIF
         ray_skip_maxdist = 0
         ray_skip_minval = 0
@@ -5602,9 +6006,16 @@
         ALLOCATE( nzterr(0:(nx+1)*(ny+1)-1) )
 #if defined( __parallel )
-        ALLOCATE( nzterrl(nys:nyn,nxl:nxr) )
+        !ALLOCATE( nzterrl(nys:nyn,nxl:nxr) )
+        ALLOCATE( nzterrl_l((nyn-nys+1)*(nxr-nxl+1)) )
+        nzterrl(nys:nyn,nxl:nxr) => nzterrl_l(1:(nyn-nys+1)*(nxr-nxl+1))
         nzterrl = get_topography_top_index( 's' )
-        CALL MPI_AllGather( nzterrl, nnx*nny, MPI_INTEGER, &
+        CALL MPI_AllGather( nzterrl_l, nnx*nny, MPI_INTEGER, &
                             nzterr, nnx*nny, MPI_INTEGER, comm2d, ierr )
-        DEALLOCATE(nzterrl)
+        IF ( ierr /= 0 ) THEN
+            WRITE(9,*) 'Error MPI_AllGather1:', ierr, SIZE(nzterrl_l), nnx*nny, &
+                       SIZE(nzterr), nnx*nny
+            FLUSH(9)
+        ENDIF
+        DEALLOCATE(nzterrl_l)
 #else
         nzterr = RESHAPE( get_topography_top_index( 's' ), (/(nx+1)*(ny+1)/) )
@@ -5621,18 +6032,43 @@
             CALL MPI_AllGather( pct, nnx*nny, MPI_INTEGER, &
                                 plantt, nnx*nny, MPI_INTEGER, comm2d, ierr )
-            
+            IF ( ierr /= 0 ) THEN
+                WRITE(9,*) 'Error MPI_AllGather2:', ierr, SIZE(pct), nnx*nny, &
+                           SIZE(plantt), nnx*nny
+                FLUSH(9)
+            ENDIF
+
 !--         temporary arrays storing values for csf calculation during raytracing
             ALLOCATE( lad_ip(maxboxesg) )
             ALLOCATE( lad_disp(maxboxesg) )
 
-            IF ( rma_lad_raytrace )  THEN
+            IF ( raytrace_mpi_rma )  THEN
                 ALLOCATE( lad_s_ray(maxboxesg) )
                 
                 ! set conditions for RMA communication
                 CALL MPI_Info_create(minfo, ierr)
+                IF ( ierr /= 0 ) THEN
+                    WRITE(9,*) 'Error MPI_Info_create2:', ierr
+                    FLUSH(9)
+                ENDIF
                 CALL MPI_Info_set(minfo, 'accumulate_ordering', '', ierr)
+                IF ( ierr /= 0 ) THEN
+                    WRITE(9,*) 'Error MPI_Info_set5:', ierr
+                    FLUSH(9)
+                ENDIF
                 CALL MPI_Info_set(minfo, 'accumulate_ops', 'same_op', ierr)
+                IF ( ierr /= 0 ) THEN
+                    WRITE(9,*) 'Error MPI_Info_set6:', ierr
+                    FLUSH(9)
+                ENDIF
                 CALL MPI_Info_set(minfo, 'same_size', 'true', ierr)
+                IF ( ierr /= 0 ) THEN
+                    WRITE(9,*) 'Error MPI_Info_set7:', ierr
+                    FLUSH(9)
+                ENDIF
                 CALL MPI_Info_set(minfo, 'same_disp_unit', 'true', ierr)
+                IF ( ierr /= 0 ) THEN
+                    WRITE(9,*) 'Error MPI_Info_set8:', ierr
+                    FLUSH(9)
+                ENDIF
 
 !--             Allocate and initialize the MPI RMA window
@@ -5643,6 +6079,11 @@
                 CALL MPI_Win_allocate(size_lad_rma, STORAGE_SIZE(1.0_wp)/8, minfo, comm2d, &
                                         lad_s_rma_p, win_lad, ierr)
-                CALL c_f_pointer(lad_s_rma_p, lad_s_rma, (/ nzp, nny, nnx /))
-                sub_lad(nzub:, nys:, nxl:) => lad_s_rma(:,:,:)
+                IF ( ierr /= 0 ) THEN
+                    WRITE(9,*) 'Error MPI_Win_allocate2:', ierr, size_lad_rma, &
+                                STORAGE_SIZE(1.0_wp)/8, win_lad
+                    FLUSH(9)
+                ENDIF
+                CALL c_f_pointer(lad_s_rma_p, lad_s_rma, (/ nzp*nny*nnx /))
+                sub_lad(nzub:nzpt, nys:nyn, nxl:nxr) => lad_s_rma(1:nzp*nny*nnx)
             ELSE
                 ALLOCATE(sub_lad(nzub:nzpt, nys:nyn, nxl:nxr))
@@ -5666,76 +6107,44 @@
 
 #if defined( __parallel )
-            IF ( rma_lad_raytrace )  THEN
+            IF ( raytrace_mpi_rma )  THEN
                 CALL MPI_Info_free(minfo, ierr)
+                IF ( ierr /= 0 ) THEN
+                    WRITE(9,*) 'Error MPI_Info_free2:', ierr
+                    FLUSH(9)
+                ENDIF
                 CALL MPI_Win_lock_all(0, win_lad, ierr)
+                IF ( ierr /= 0 ) THEN
+                    WRITE(9,*) 'Error MPI_Win_lock_all1:', ierr, win_lad
+                    FLUSH(9)
+                ENDIF
+                
             ELSE
                 ALLOCATE( sub_lad_g(0:(nx+1)*(ny+1)*nzp-1) )
                 CALL MPI_AllGather( sub_lad, nnx*nny*nzp, MPI_REAL, &
                                     sub_lad_g, nnx*nny*nzp, MPI_REAL, comm2d, ierr )
+                IF ( ierr /= 0 ) THEN
+                    WRITE(9,*) 'Error MPI_AllGather3:', ierr, SIZE(sub_lad), &
+                                nnx*nny*nzp, SIZE(sub_lad_g), nnx*nny*nzp
+                    FLUSH(9)
+                ENDIF
             ENDIF
 #endif
         ENDIF
 
-        IF ( mrt_factors )  THEN
-            OPEN(153, file='MRT_TARGETS', access='SEQUENTIAL', &
-                    action='READ', status='OLD', form='FORMATTED', err=524)
-            OPEN(154, file='MRT_FACTORS'//myid_char, access='DIRECT', recl=(5*4+2*8), &
-                    action='WRITE', status='REPLACE', form='UNFORMATTED', err=525)
-            imrtf = 1
-            DO
-                READ(153, *, end=526, err=524) imrtt, i, j, k
-                IF ( i < nxl  .OR.  i > nxr &
-                     .OR.  j < nys  .OR.  j > nyn ) CYCLE
-                ta = (/ REAL(k), REAL(j), REAL(i) /)
-
-                DO isurfs = 1, nsurf
-                    IF ( .NOT.  surface_facing(i, j, k, -1, &
-                        surf(ix, isurfs), surf(iy, isurfs), &
-                        surf(iz, isurfs), surf(id, isurfs)) )  THEN
-                        CYCLE
-                    ENDIF
-                      
-                    sd = surf(id, isurfs)
-                    sa = (/ REAL(surf(iz, isurfs), wp) - 0.5_wp * kdir(sd), &
-                            REAL(surf(iy, isurfs), wp) - 0.5_wp * jdir(sd), &
-                            REAL(surf(ix, isurfs), wp) - 0.5_wp * idir(sd) /)
-
-!--                 unit vector source -> target
-                    uv = (/ (ta(1)-sa(1))*dz(1), (ta(2)-sa(2))*dy, (ta(3)-sa(3))*dx /)
-                    sqdist = SUM(uv(:)**2)
-                    uv = uv / SQRT(sqdist)
-
-!--                 irradiance factor - see svf. Here we consider that target face is always normal,
-!--                 i.e. the second dot product equals 1
-                    rirrf = dot_product((/ kdir(sd), jdir(sd), idir(sd) /), uv) &
-                        / (pi * sqdist) * facearea(sd)
-
-!--                 raytrace while not creating any canopy sink factors
-                    CALL raytrace(sa, ta, isurfs, rirrf, 1._wp, .FALSE., &
-                            visible, transparency, win_lad)
-                    IF ( .NOT.  visible ) CYCLE
-
-                    !rsvf = rirrf * transparency
-                    WRITE(154, rec=imrtf, err=525) INT(imrtt, kind=4), &
-                        INT(surf(id, isurfs), kind=4), &
-                        INT(surf(iz, isurfs), kind=4), &
-                        INT(surf(iy, isurfs), kind=4), &
-                        INT(surf(ix, isurfs), kind=4), &
-                        REAL(rirrf, kind=8), REAL(transparency, kind=8)
-                    imrtf = imrtf + 1
-
-                ENDDO !< isurfs
-            ENDDO !< MRT_TARGETS record
-
-524         message_string = 'error reading file MRT_TARGETS'
-            CALL message( 'radiation_calc_svf', 'PA0524', 1, 2, 0, 6, 0 )
-
-525         message_string = 'error writing file MRT_FACTORS'//myid_char
-            CALL message( 'radiation_calc_svf', 'PA0525', 1, 2, 0, 6, 0 )
-
-526         CLOSE(153)
-            CLOSE(154)
-        ENDIF  !< mrt_factors
-        
+!--     prepare the MPI_Win for collecting the surface indices
+!--     from the reverse index arrays gridsurf from processors of target surfaces
+#if defined( __parallel )
+        IF ( rad_angular_discretization )  THEN
+!
+!--         raytrace_mpi_rma is asserted
+            CALL MPI_Win_lock_all(0, win_gridsurf, ierr)
+            IF ( ierr /= 0 ) THEN
+                WRITE(9,*) 'Error MPI_Win_lock_all2:', ierr, win_gridsurf
+                FLUSH(9)
+            ENDIF
+        ENDIF
+#endif
+
+
         !--Directions opposite to face normals are not even calculated,
         !--they must be preset to 0
@@ -5798,14 +6207,23 @@
             END SELECT
 
-            ALLOCATE ( zdirs(1:nzn), zbdry(0:nzn), vffrac(1:nzn), ztransp(1:nzn) )
+            ALLOCATE ( zdirs(1:nzn), zbdry(0:nzn), vffrac(1:nzn*naz), &
+                       ztransp(1:nzn*naz), itarget(1:nzn*naz) )   !FIXME allocate itarget only
+                                                                  !in case of rad_angular_discretization
+
+            itarg0 = 1
+            itarg1 = nzn
             zdirs(:) = (/( TAN(pi/2 - (zn0+(REAL(izn,wp)-.5_wp)*zns)), izn=1, nzn )/)
             zbdry(:) = (/( zn0+REAL(izn,wp)*zns, izn=0, nzn )/)
             IF ( td == iup_u  .OR.  td == iup_l )  THEN
-               !-- For horizontal target, vf fractions are constant per azimuth
-               vffrac(:) = (COS(2 * zbdry(0:nzn-1)) - COS(2 * zbdry(1:nzn))) / 2._wp / REAL(naz, wp)
-               !--sum of vffrac for all iaz equals 1, verified
+               vffrac(1:nzn) = (COS(2 * zbdry(0:nzn-1)) - COS(2 * zbdry(1:nzn))) / 2._wp / REAL(naz, wp)
+!
+!--            For horizontal target, vf fractions are constant per azimuth
+               DO iaz = 1, naz-1
+                  vffrac(iaz*nzn+1:(iaz+1)*nzn) = vffrac(1:nzn)
+               ENDDO
+!--            sum of whole vffrac equals 1, verified
             ENDIF
-
-            !--Calculate sky-view factor and direct solar visibility using 2D raytracing
+!
+!--         Calculate sky-view factor and direct solar visibility using 2D raytracing
             DO iaz = 1, naz
                azmid = az0 + (REAL(iaz, wp) - .5_wp) * azs
